<?php

namespace Teknisa\FIN\Modules\ContaReceber\Services;

use Doctrine\ORM\EntityManager;
use Teknisa\FIN\Modules\ContaReceber\Factory\GeralRecTipoajreceberFactory;

class GeralRecTipoajreceberService{

    protected $environment;
    protected $newCode;
    protected $entityManager;
    protected $factory;

    public function __construct($environment, $newCode, EntityManager $entityManager,
                                GeralRecTipoajreceberFactory $factory) {
        $this->environment = $environment;
        $this->newCode = $newCode;
        $this->entityManager = $entityManager;
        $this->factory = $factory;
	}

    public function insereParametroContaReceber($idbloqincntr, $idtpcntrlib, $idutctrlcanremr,
                                     $idbloqaltbolrec, $idutlnfdevolrec, $idutbcoprefclie,
                                     $idextelacalajubx){
        $connection = $this->entityManager->getConnection();
        $connection->beginTransaction();
        try {
            $cdgeralrec = $this->newCode->getCodeByTableName('GERAL_REC',$this->environment->getNrOrgTrab());
            $geralrec = $this->factory->insereParametroContaReceber(intVal($cdgeralrec), $idbloqincntr, $idtpcntrlib, $idutctrlcanremr,
                $idbloqaltbolrec, $idutlnfdevolrec, $idutbcoprefclie, $idextelacalajubx,$this->environment->getNrOrgTrab());
            $this->entityManager->persist($geralrec);
            $this->entityManager->flush();

            $this->entityManager->flush();
            $connection->commit();
        } catch (\Exception $e) {
            $connection->rollBack();
            throw $e;
        }
    }
}